-- Created with matlab script get_rom_coefficients.m 
-- Using matlab function "generate_MaxFlt_centered(64,12)" to generate the filter taps
-- Creation date : 18-Aug-2024 18:36:45 

library IEEE, common_lib;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.NUMERIC_STD.ALL;
use common_lib.common_pkg.all;
 
entity PSSFIRTaps is
    port(
        clk      : in std_logic;
        i_addr   : in t_slv_6_arr(11 downto 0);   -- 12 ROMs, 64 entries each
        -- read data, 1 clock latency 
        o_coef   : out t_slv_18_arr(11 downto 0)   -- 18 bits per filter tap.
    );
end PSSFIRTaps;

architecture Behavioral of PSSFIRTaps is

    signal coef_int : t_slv_18_arr(11 downto 0);
begin
   
    process(clk)
    begin
        if rising_edge(clk) then
            o_coef(0) <= coef_int(0);
            o_coef(1) <= coef_int(1);
            o_coef(2) <= coef_int(2);
            o_coef(3) <= coef_int(3);
            o_coef(4) <= coef_int(4);
            o_coef(5) <= coef_int(5);
            o_coef(6) <= coef_int(6);
            o_coef(7) <= coef_int(7);
            o_coef(8) <= coef_int(8);
            o_coef(9) <= coef_int(9);
            o_coef(10) <= coef_int(10);
            o_coef(11) <= coef_int(11);
        end if;
    end process;
    with i_addr(0) select 
    coef_int(0) <= 
        "000000000000001010" when "000000",
        "000000000000001011" when "000001",
        "000000000000001100" when "000010",
        "000000000000001110" when "000011",
        "000000000000001111" when "000100",
        "000000000000010000" when "000101",
        "000000000000010001" when "000110",
        "000000000000010001" when "000111",
        "000000000000010010" when "001000",
        "000000000000010010" when "001001",
        "000000000000010011" when "001010",
        "000000000000010011" when "001011",
        "000000000000010011" when "001100",
        "000000000000010011" when "001101",
        "000000000000010011" when "001110",
        "000000000000010011" when "001111",
        "000000000000010010" when "010000",
        "000000000000010010" when "010001",
        "000000000000010001" when "010010",
        "000000000000010000" when "010011",
        "000000000000010000" when "010100",
        "000000000000001111" when "010101",
        "000000000000001110" when "010110",
        "000000000000001101" when "010111",
        "000000000000001100" when "011000",
        "000000000000001010" when "011001",
        "000000000000001001" when "011010",
        "000000000000001000" when "011011",
        "000000000000000110" when "011100",
        "000000000000000101" when "011101",
        "000000000000000100" when "011110",
        "000000000000000010" when "011111",
        "000000000000000001" when "100000",
        "000000000000000000" when "100001",
        "111111111111111110" when "100010",
        "111111111111111101" when "100011",
        "111111111111111011" when "100100",
        "111111111111111010" when "100101",
        "111111111111111001" when "100110",
        "111111111111111000" when "100111",
        "111111111111110110" when "101000",
        "111111111111110101" when "101001",
        "111111111111110100" when "101010",
        "111111111111110011" when "101011",
        "111111111111110010" when "101100",
        "111111111111110010" when "101101",
        "111111111111110001" when "101110",
        "111111111111110000" when "101111",
        "111111111111110000" when "110000",
        "111111111111101111" when "110001",
        "111111111111101111" when "110010",
        "111111111111101111" when "110011",
        "111111111111101110" when "110100",
        "111111111111101110" when "110101",
        "111111111111101110" when "110110",
        "111111111111101110" when "110111",
        "111111111111101110" when "111000",
        "111111111111101111" when "111001",
        "111111111111101111" when "111010",
        "111111111111101111" when "111011",
        "111111111111110000" when "111100",
        "111111111111110000" when "111101",
        "111111111111110001" when "111110",
        "111111111111110010" when others;
    with i_addr(1) select 
    coef_int(1) <= 
        "000000000011010011" when "000000",
        "000000000011001111" when "000001",
        "000000000011001001" when "000010",
        "000000000011000100" when "000011",
        "000000000010111110" when "000100",
        "000000000010110111" when "000101",
        "000000000010110000" when "000110",
        "000000000010101001" when "000111",
        "000000000010100001" when "001000",
        "000000000010011001" when "001001",
        "000000000010010001" when "001010",
        "000000000010001001" when "001011",
        "000000000010000001" when "001100",
        "000000000001111001" when "001101",
        "000000000001110000" when "001110",
        "000000000001101000" when "001111",
        "000000000001100000" when "010000",
        "000000000001011000" when "010001",
        "000000000001010000" when "010010",
        "000000000001001001" when "010011",
        "000000000001000001" when "010100",
        "000000000000111010" when "010101",
        "000000000000110011" when "010110",
        "000000000000101101" when "010111",
        "000000000000100110" when "011000",
        "000000000000100000" when "011001",
        "000000000000011011" when "011010",
        "000000000000010101" when "011011",
        "000000000000010000" when "011100",
        "000000000000001100" when "011101",
        "000000000000000111" when "011110",
        "000000000000000100" when "011111",
        "000000000000000000" when "100000",
        "111111111111111101" when "100001",
        "111111111111111010" when "100010",
        "111111111111110111" when "100011",
        "111111111111110101" when "100100",
        "111111111111110011" when "100101",
        "111111111111110010" when "100110",
        "111111111111110001" when "100111",
        "111111111111110000" when "101000",
        "111111111111101111" when "101001",
        "111111111111101111" when "101010",
        "111111111111101111" when "101011",
        "111111111111101111" when "101100",
        "111111111111101111" when "101101",
        "111111111111110000" when "101110",
        "111111111111110000" when "101111",
        "111111111111110001" when "110000",
        "111111111111110010" when "110001",
        "111111111111110100" when "110010",
        "111111111111110101" when "110011",
        "111111111111110110" when "110100",
        "111111111111111000" when "110101",
        "111111111111111010" when "110110",
        "111111111111111011" when "110111",
        "111111111111111101" when "111000",
        "111111111111111111" when "111001",
        "000000000000000000" when "111010",
        "000000000000000010" when "111011",
        "000000000000000100" when "111100",
        "000000000000000101" when "111101",
        "000000000000000111" when "111110",
        "000000000000001000" when others;
    with i_addr(2) select 
    coef_int(2) <= 
        "111111101110011101" when "000000",
        "111111101110001111" when "000001",
        "111111101110000111" when "000010",
        "111111101110000010" when "000011",
        "111111101110000010" when "000100",
        "111111101110000110" when "000101",
        "111111101110001110" when "000110",
        "111111101110011001" when "000111",
        "111111101110101000" when "001000",
        "111111101110111010" when "001001",
        "111111101111001111" when "001010",
        "111111101111100111" when "001011",
        "111111110000000010" when "001100",
        "111111110000011110" when "001101",
        "111111110000111101" when "001110",
        "111111110001011110" when "001111",
        "111111110010000001" when "010000",
        "111111110010100101" when "010001",
        "111111110011001010" when "010010",
        "111111110011110000" when "010011",
        "111111110100011000" when "010100",
        "111111110101000000" when "010101",
        "111111110101101000" when "010110",
        "111111110110010001" when "010111",
        "111111110110111010" when "011000",
        "111111110111100011" when "011001",
        "111111111000001100" when "011010",
        "111111111000110101" when "011011",
        "111111111001011101" when "011100",
        "111111111010000100" when "011101",
        "111111111010101011" when "011110",
        "111111111011010001" when "011111",
        "111111111011110111" when "100000",
        "111111111100011011" when "100001",
        "111111111100111110" when "100010",
        "111111111101011111" when "100011",
        "111111111110000000" when "100100",
        "111111111110011111" when "100101",
        "111111111110111101" when "100110",
        "111111111111011001" when "100111",
        "111111111111110100" when "101000",
        "000000000000001110" when "101001",
        "000000000000100110" when "101010",
        "000000000000111100" when "101011",
        "000000000001010001" when "101100",
        "000000000001100101" when "101101",
        "000000000001110110" when "101110",
        "000000000010000111" when "101111",
        "000000000010010101" when "110000",
        "000000000010100011" when "110001",
        "000000000010101111" when "110010",
        "000000000010111001" when "110011",
        "000000000011000010" when "110100",
        "000000000011001010" when "110101",
        "000000000011010000" when "110110",
        "000000000011010101" when "110111",
        "000000000011011001" when "111000",
        "000000000011011100" when "111001",
        "000000000011011101" when "111010",
        "000000000011011110" when "111011",
        "000000000011011101" when "111100",
        "000000000011011100" when "111101",
        "000000000011011010" when "111110",
        "000000000011010111" when others;
    with i_addr(3) select 
    coef_int(3) <= 
        "000000110001011010" when "000000",
        "000000110011110110" when "000001",
        "000000110110000011" when "000010",
        "000000110111111110" when "000011",
        "000000111001101010" when "000100",
        "000000111011000101" when "000101",
        "000000111100010000" when "000110",
        "000000111101001100" when "000111",
        "000000111101111001" when "001000",
        "000000111110011000" when "001001",
        "000000111110101000" when "001010",
        "000000111110101010" when "001011",
        "000000111110011111" when "001100",
        "000000111110000111" when "001101",
        "000000111101100011" when "001110",
        "000000111100110100" when "001111",
        "000000111011111010" when "010000",
        "000000111010110101" when "010001",
        "000000111001100110" when "010010",
        "000000111000001111" when "010011",
        "000000110110101111" when "010100",
        "000000110101000111" when "010101",
        "000000110011011000" when "010110",
        "000000110001100010" when "010111",
        "000000101111100110" when "011000",
        "000000101101100110" when "011001",
        "000000101011100000" when "011010",
        "000000101001010111" when "011011",
        "000000100111001011" when "011100",
        "000000100100111011" when "011101",
        "000000100010101010" when "011110",
        "000000100000010111" when "011111",
        "000000011110000011" when "100000",
        "000000011011101111" when "100001",
        "000000011001011011" when "100010",
        "000000010111000111" when "100011",
        "000000010100110101" when "100100",
        "000000010010100100" when "100101",
        "000000010000010101" when "100110",
        "000000001110001001" when "100111",
        "000000001011111111" when "101000",
        "000000001001111001" when "101001",
        "000000000111110110" when "101010",
        "000000000101110111" when "101011",
        "000000000011111100" when "101100",
        "000000000010000101" when "101101",
        "000000000000010011" when "101110",
        "111111111110100110" when "101111",
        "111111111100111110" when "110000",
        "111111111011011011" when "110001",
        "111111111001111101" when "110010",
        "111111111000100100" when "110011",
        "111111110111010010" when "110100",
        "111111110110000100" when "110101",
        "111111110100111101" when "110110",
        "111111110011111011" when "110111",
        "111111110010111110" when "111000",
        "111111110010000111" when "111001",
        "111111110001010110" when "111010",
        "111111110000101010" when "111011",
        "111111110000000011" when "111100",
        "111111101111100010" when "111101",
        "111111101111000110" when "111110",
        "111111101110101111" when others;
    with i_addr(4) select 
    coef_int(4) <= 
        "111110100111011110" when "000000",
        "111110011011100111" when "000001",
        "111110010000100010" when "000010",
        "111110000110010001" when "000011",
        "111101111100110011" when "000100",
        "111101110100001000" when "000101",
        "111101101100001110" when "000110",
        "111101100101000111" when "000111",
        "111101011110110001" when "001000",
        "111101011001001011" when "001001",
        "111101010100010101" when "001010",
        "111101010000001110" when "001011",
        "111101001100110100" when "001100",
        "111101001010000111" when "001101",
        "111101001000000101" when "001110",
        "111101000110101110" when "001111",
        "111101000101111111" when "010000",
        "111101000101111000" when "010001",
        "111101000110010111" when "010010",
        "111101000111011011" when "010011",
        "111101001001000001" when "010100",
        "111101001011001001" when "010101",
        "111101001101110001" when "010110",
        "111101010000110111" when "010111",
        "111101010100011001" when "011000",
        "111101011000010110" when "011001",
        "111101011100101011" when "011010",
        "111101100001011000" when "011011",
        "111101100110011010" when "011100",
        "111101101011101111" when "011101",
        "111101110001010111" when "011110",
        "111101110111001110" when "011111",
        "111101111101010011" when "100000",
        "111110000011100110" when "100001",
        "111110001010000011" when "100010",
        "111110010000101001" when "100011",
        "111110010111010110" when "100100",
        "111110011110001010" when "100101",
        "111110100101000001" when "100110",
        "111110101011111011" when "100111",
        "111110110010110111" when "101000",
        "111110111001110010" when "101001",
        "111111000000101100" when "101010",
        "111111000111100010" when "101011",
        "111111001110010101" when "101100",
        "111111010101000010" when "101101",
        "111111011011101000" when "101110",
        "111111100010000110" when "101111",
        "111111101000011011" when "110000",
        "111111101110100110" when "110001",
        "111111110100100111" when "110010",
        "111111111010011100" when "110011",
        "000000000000000100" when "110100",
        "000000000101100000" when "110101",
        "000000001010101101" when "110110",
        "000000001111101100" when "110111",
        "000000010100011100" when "111000",
        "000000011000111101" when "111001",
        "000000011101001110" when "111010",
        "000000100001001110" when "111011",
        "000000100100111111" when "111100",
        "000000101000011111" when "111101",
        "000000101011101110" when "111110",
        "000000101110101100" when others;
    with i_addr(5) select 
    coef_int(5) <= 
        "010001101011000011" when "000000",
        "010001101010011100" when "000001",
        "010001101000101001" when "000010",
        "010001100101101001" when "000011",
        "010001100001011101" when "000100",
        "010001011100000110" when "000101",
        "010001010101100100" when "000110",
        "010001001101110111" when "000111",
        "010001000101000010" when "001000",
        "010000111011000101" when "001001",
        "010000110000000001" when "001010",
        "010000100011111001" when "001011",
        "010000010110101101" when "001100",
        "010000001000100000" when "001101",
        "001111111001010011" when "001110",
        "001111101001001000" when "001111",
        "001111011000000001" when "010000",
        "001111000110000001" when "010001",
        "001110110011001011" when "010010",
        "001110011111011111" when "010011",
        "001110001011000010" when "010100",
        "001101110101110101" when "010101",
        "001101011111111100" when "010110",
        "001101001001011000" when "010111",
        "001100110010001110" when "011000",
        "001100011010100000" when "011001",
        "001100000010010001" when "011010",
        "001011101001100011" when "011011",
        "001011010000011011" when "011100",
        "001010110110111011" when "011101",
        "001010011101000110" when "011110",
        "001010000010111111" when "011111",
        "001001101000101010" when "100000",
        "001001001110001001" when "100001",
        "001000110011100000" when "100010",
        "001000011000110010" when "100011",
        "000111111110000010" when "100100",
        "000111100011010011" when "100101",
        "000111001000101000" when "100110",
        "000110101110000100" when "100111",
        "000110010011101010" when "101000",
        "000101111001011100" when "101001",
        "000101011111011111" when "101010",
        "000101000101110011" when "101011",
        "000100101100011100" when "101100",
        "000100010011011101" when "101101",
        "000011111010111000" when "101110",
        "000011100010101110" when "101111",
        "000011001011000100" when "110000",
        "000010110011111010" when "110001",
        "000010011101010011" when "110010",
        "000010000111010001" when "110011",
        "000001110001110101" when "110100",
        "000001011101000010" when "110101",
        "000001001000111000" when "110110",
        "000000110101011010" when "110111",
        "000000100010101000" when "111000",
        "000000010000100101" when "111001",
        "111111111111010000" when "111010",
        "111111101110101100" when "111011",
        "111111011110111000" when "111100",
        "111111001111110110" when "111101",
        "111111000001100110" when "111110",
        "111110110100001001" when others;
    with i_addr(6) select 
    coef_int(6) <= 
        "111110100111011110" when "000000",
        "111110110100001001" when "000001",
        "111111000001100110" when "000010",
        "111111001111110110" when "000011",
        "111111011110111000" when "000100",
        "111111101110101100" when "000101",
        "111111111111010000" when "000110",
        "000000010000100101" when "000111",
        "000000100010101000" when "001000",
        "000000110101011010" when "001001",
        "000001001000111000" when "001010",
        "000001011101000010" when "001011",
        "000001110001110101" when "001100",
        "000010000111010001" when "001101",
        "000010011101010011" when "001110",
        "000010110011111010" when "001111",
        "000011001011000100" when "010000",
        "000011100010101110" when "010001",
        "000011111010111000" when "010010",
        "000100010011011101" when "010011",
        "000100101100011100" when "010100",
        "000101000101110011" when "010101",
        "000101011111011111" when "010110",
        "000101111001011100" when "010111",
        "000110010011101010" when "011000",
        "000110101110000100" when "011001",
        "000111001000101000" when "011010",
        "000111100011010011" when "011011",
        "000111111110000010" when "011100",
        "001000011000110010" when "011101",
        "001000110011100000" when "011110",
        "001001001110001001" when "011111",
        "001001101000101010" when "100000",
        "001010000010111111" when "100001",
        "001010011101000110" when "100010",
        "001010110110111011" when "100011",
        "001011010000011011" when "100100",
        "001011101001100011" when "100101",
        "001100000010010001" when "100110",
        "001100011010100000" when "100111",
        "001100110010001110" when "101000",
        "001101001001011000" when "101001",
        "001101011111111100" when "101010",
        "001101110101110101" when "101011",
        "001110001011000010" when "101100",
        "001110011111011111" when "101101",
        "001110110011001011" when "101110",
        "001111000110000001" when "101111",
        "001111011000000001" when "110000",
        "001111101001001000" when "110001",
        "001111111001010011" when "110010",
        "010000001000100000" when "110011",
        "010000010110101101" when "110100",
        "010000100011111001" when "110101",
        "010000110000000001" when "110110",
        "010000111011000101" when "110111",
        "010001000101000010" when "111000",
        "010001001101110111" when "111001",
        "010001010101100100" when "111010",
        "010001011100000110" when "111011",
        "010001100001011101" when "111100",
        "010001100101101001" when "111101",
        "010001101000101001" when "111110",
        "010001101010011100" when others;
    with i_addr(7) select 
    coef_int(7) <= 
        "000000110001011010" when "000000",
        "000000101110101100" when "000001",
        "000000101011101110" when "000010",
        "000000101000011111" when "000011",
        "000000100100111111" when "000100",
        "000000100001001110" when "000101",
        "000000011101001110" when "000110",
        "000000011000111101" when "000111",
        "000000010100011100" when "001000",
        "000000001111101100" when "001001",
        "000000001010101101" when "001010",
        "000000000101100000" when "001011",
        "000000000000000100" when "001100",
        "111111111010011100" when "001101",
        "111111110100100111" when "001110",
        "111111101110100110" when "001111",
        "111111101000011011" when "010000",
        "111111100010000110" when "010001",
        "111111011011101000" when "010010",
        "111111010101000010" when "010011",
        "111111001110010101" when "010100",
        "111111000111100010" when "010101",
        "111111000000101100" when "010110",
        "111110111001110010" when "010111",
        "111110110010110111" when "011000",
        "111110101011111011" when "011001",
        "111110100101000001" when "011010",
        "111110011110001010" when "011011",
        "111110010111010110" when "011100",
        "111110010000101001" when "011101",
        "111110001010000011" when "011110",
        "111110000011100110" when "011111",
        "111101111101010011" when "100000",
        "111101110111001110" when "100001",
        "111101110001010111" when "100010",
        "111101101011101111" when "100011",
        "111101100110011010" when "100100",
        "111101100001011000" when "100101",
        "111101011100101011" when "100110",
        "111101011000010110" when "100111",
        "111101010100011001" when "101000",
        "111101010000110111" when "101001",
        "111101001101110001" when "101010",
        "111101001011001001" when "101011",
        "111101001001000001" when "101100",
        "111101000111011011" when "101101",
        "111101000110010111" when "101110",
        "111101000101111000" when "101111",
        "111101000101111111" when "110000",
        "111101000110101110" when "110001",
        "111101001000000101" when "110010",
        "111101001010000111" when "110011",
        "111101001100110100" when "110100",
        "111101010000001110" when "110101",
        "111101010100010101" when "110110",
        "111101011001001011" when "110111",
        "111101011110110001" when "111000",
        "111101100101000111" when "111001",
        "111101101100001110" when "111010",
        "111101110100001000" when "111011",
        "111101111100110011" when "111100",
        "111110000110010001" when "111101",
        "111110010000100010" when "111110",
        "111110011011100111" when others;
    with i_addr(8) select 
    coef_int(8) <= 
        "111111101110011101" when "000000",
        "111111101110101111" when "000001",
        "111111101111000110" when "000010",
        "111111101111100010" when "000011",
        "111111110000000011" when "000100",
        "111111110000101010" when "000101",
        "111111110001010110" when "000110",
        "111111110010000111" when "000111",
        "111111110010111110" when "001000",
        "111111110011111011" when "001001",
        "111111110100111101" when "001010",
        "111111110110000100" when "001011",
        "111111110111010010" when "001100",
        "111111111000100100" when "001101",
        "111111111001111101" when "001110",
        "111111111011011011" when "001111",
        "111111111100111110" when "010000",
        "111111111110100110" when "010001",
        "000000000000010011" when "010010",
        "000000000010000101" when "010011",
        "000000000011111100" when "010100",
        "000000000101110111" when "010101",
        "000000000111110110" when "010110",
        "000000001001111001" when "010111",
        "000000001011111111" when "011000",
        "000000001110001001" when "011001",
        "000000010000010101" when "011010",
        "000000010010100100" when "011011",
        "000000010100110101" when "011100",
        "000000010111000111" when "011101",
        "000000011001011011" when "011110",
        "000000011011101111" when "011111",
        "000000011110000011" when "100000",
        "000000100000010111" when "100001",
        "000000100010101010" when "100010",
        "000000100100111011" when "100011",
        "000000100111001011" when "100100",
        "000000101001010111" when "100101",
        "000000101011100000" when "100110",
        "000000101101100110" when "100111",
        "000000101111100110" when "101000",
        "000000110001100010" when "101001",
        "000000110011011000" when "101010",
        "000000110101000111" when "101011",
        "000000110110101111" when "101100",
        "000000111000001111" when "101101",
        "000000111001100110" when "101110",
        "000000111010110101" when "101111",
        "000000111011111010" when "110000",
        "000000111100110100" when "110001",
        "000000111101100011" when "110010",
        "000000111110000111" when "110011",
        "000000111110011111" when "110100",
        "000000111110101010" when "110101",
        "000000111110101000" when "110110",
        "000000111110011000" when "110111",
        "000000111101111001" when "111000",
        "000000111101001100" when "111001",
        "000000111100010000" when "111010",
        "000000111011000101" when "111011",
        "000000111001101010" when "111100",
        "000000110111111110" when "111101",
        "000000110110000011" when "111110",
        "000000110011110110" when others;
    with i_addr(9) select 
    coef_int(9) <= 
        "000000000011010011" when "000000",
        "000000000011010111" when "000001",
        "000000000011011010" when "000010",
        "000000000011011100" when "000011",
        "000000000011011101" when "000100",
        "000000000011011110" when "000101",
        "000000000011011101" when "000110",
        "000000000011011100" when "000111",
        "000000000011011001" when "001000",
        "000000000011010101" when "001001",
        "000000000011010000" when "001010",
        "000000000011001010" when "001011",
        "000000000011000010" when "001100",
        "000000000010111001" when "001101",
        "000000000010101111" when "001110",
        "000000000010100011" when "001111",
        "000000000010010101" when "010000",
        "000000000010000111" when "010001",
        "000000000001110110" when "010010",
        "000000000001100101" when "010011",
        "000000000001010001" when "010100",
        "000000000000111100" when "010101",
        "000000000000100110" when "010110",
        "000000000000001110" when "010111",
        "111111111111110100" when "011000",
        "111111111111011001" when "011001",
        "111111111110111101" when "011010",
        "111111111110011111" when "011011",
        "111111111110000000" when "011100",
        "111111111101011111" when "011101",
        "111111111100111110" when "011110",
        "111111111100011011" when "011111",
        "111111111011110111" when "100000",
        "111111111011010001" when "100001",
        "111111111010101011" when "100010",
        "111111111010000100" when "100011",
        "111111111001011101" when "100100",
        "111111111000110101" when "100101",
        "111111111000001100" when "100110",
        "111111110111100011" when "100111",
        "111111110110111010" when "101000",
        "111111110110010001" when "101001",
        "111111110101101000" when "101010",
        "111111110101000000" when "101011",
        "111111110100011000" when "101100",
        "111111110011110000" when "101101",
        "111111110011001010" when "101110",
        "111111110010100101" when "101111",
        "111111110010000001" when "110000",
        "111111110001011110" when "110001",
        "111111110000111101" when "110010",
        "111111110000011110" when "110011",
        "111111110000000010" when "110100",
        "111111101111100111" when "110101",
        "111111101111001111" when "110110",
        "111111101110111010" when "110111",
        "111111101110101000" when "111000",
        "111111101110011001" when "111001",
        "111111101110001110" when "111010",
        "111111101110000110" when "111011",
        "111111101110000010" when "111100",
        "111111101110000010" when "111101",
        "111111101110000111" when "111110",
        "111111101110001111" when others;
    with i_addr(10) select 
    coef_int(10) <= 
        "000000000000001010" when "000000",
        "000000000000001000" when "000001",
        "000000000000000111" when "000010",
        "000000000000000101" when "000011",
        "000000000000000100" when "000100",
        "000000000000000010" when "000101",
        "000000000000000000" when "000110",
        "111111111111111111" when "000111",
        "111111111111111101" when "001000",
        "111111111111111011" when "001001",
        "111111111111111010" when "001010",
        "111111111111111000" when "001011",
        "111111111111110110" when "001100",
        "111111111111110101" when "001101",
        "111111111111110100" when "001110",
        "111111111111110010" when "001111",
        "111111111111110001" when "010000",
        "111111111111110000" when "010001",
        "111111111111110000" when "010010",
        "111111111111101111" when "010011",
        "111111111111101111" when "010100",
        "111111111111101111" when "010101",
        "111111111111101111" when "010110",
        "111111111111101111" when "010111",
        "111111111111110000" when "011000",
        "111111111111110001" when "011001",
        "111111111111110010" when "011010",
        "111111111111110011" when "011011",
        "111111111111110101" when "011100",
        "111111111111110111" when "011101",
        "111111111111111010" when "011110",
        "111111111111111101" when "011111",
        "000000000000000000" when "100000",
        "000000000000000100" when "100001",
        "000000000000000111" when "100010",
        "000000000000001100" when "100011",
        "000000000000010000" when "100100",
        "000000000000010101" when "100101",
        "000000000000011011" when "100110",
        "000000000000100000" when "100111",
        "000000000000100110" when "101000",
        "000000000000101101" when "101001",
        "000000000000110011" when "101010",
        "000000000000111010" when "101011",
        "000000000001000001" when "101100",
        "000000000001001001" when "101101",
        "000000000001010000" when "101110",
        "000000000001011000" when "101111",
        "000000000001100000" when "110000",
        "000000000001101000" when "110001",
        "000000000001110000" when "110010",
        "000000000001111001" when "110011",
        "000000000010000001" when "110100",
        "000000000010001001" when "110101",
        "000000000010010001" when "110110",
        "000000000010011001" when "110111",
        "000000000010100001" when "111000",
        "000000000010101001" when "111001",
        "000000000010110000" when "111010",
        "000000000010110111" when "111011",
        "000000000010111110" when "111100",
        "000000000011000100" when "111101",
        "000000000011001001" when "111110",
        "000000000011001111" when others;
    with i_addr(11) select 
    coef_int(11) <= 
        "111111111111110101" when "000000",
        "111111111111110010" when "000001",
        "111111111111110001" when "000010",
        "111111111111110000" when "000011",
        "111111111111110000" when "000100",
        "111111111111101111" when "000101",
        "111111111111101111" when "000110",
        "111111111111101111" when "000111",
        "111111111111101110" when "001000",
        "111111111111101110" when "001001",
        "111111111111101110" when "001010",
        "111111111111101110" when "001011",
        "111111111111101110" when "001100",
        "111111111111101111" when "001101",
        "111111111111101111" when "001110",
        "111111111111101111" when "001111",
        "111111111111110000" when "010000",
        "111111111111110000" when "010001",
        "111111111111110001" when "010010",
        "111111111111110010" when "010011",
        "111111111111110010" when "010100",
        "111111111111110011" when "010101",
        "111111111111110100" when "010110",
        "111111111111110101" when "010111",
        "111111111111110110" when "011000",
        "111111111111111000" when "011001",
        "111111111111111001" when "011010",
        "111111111111111010" when "011011",
        "111111111111111011" when "011100",
        "111111111111111101" when "011101",
        "111111111111111110" when "011110",
        "000000000000000000" when "011111",
        "000000000000000001" when "100000",
        "000000000000000010" when "100001",
        "000000000000000100" when "100010",
        "000000000000000101" when "100011",
        "000000000000000110" when "100100",
        "000000000000001000" when "100101",
        "000000000000001001" when "100110",
        "000000000000001010" when "100111",
        "000000000000001100" when "101000",
        "000000000000001101" when "101001",
        "000000000000001110" when "101010",
        "000000000000001111" when "101011",
        "000000000000010000" when "101100",
        "000000000000010000" when "101101",
        "000000000000010001" when "101110",
        "000000000000010010" when "101111",
        "000000000000010010" when "110000",
        "000000000000010011" when "110001",
        "000000000000010011" when "110010",
        "000000000000010011" when "110011",
        "000000000000010011" when "110100",
        "000000000000010011" when "110101",
        "000000000000010011" when "110110",
        "000000000000010010" when "110111",
        "000000000000010010" when "111000",
        "000000000000010001" when "111001",
        "000000000000010001" when "111010",
        "000000000000010000" when "111011",
        "000000000000001111" when "111100",
        "000000000000001110" when "111101",
        "000000000000001100" when "111110",
        "000000000000001011" when others;
end;
